<template>
    <div
        class="w-full"
    >
        <header-circle-container>
            <div
                class="mt-2 mb-4"
            >
                <img
                    :src="'/img/logo.png'"
                    class="mx-auto w-24"
                />
            </div>
            <div
                class="flex justify-start space-x-4 sm:space-x-2 mb-14 py-2 overflow-x-scroll"
            >
                <a
                    href="javascript:"
                    class="capitalize px-4 py-2 rounded-full sm:text-xs"
                    :class="{
                        'bg-white border-2 border-neutral text-neutral': category === 'all',
                        'bg-neutral border-2 border-white text-white': category !== 'all'
                    }"
                    @click="category = 'all'"
                >
                    {{ $t('all') }}
                </a>
                <a
                    href="javascript:"
                    class="capitalize px-4 py-2 rounded-full sm:text-xs relative"
                    :class="{
                        'bg-white border-2 border-neutral text-neutral': category === 'news',
                        'bg-neutral border-2 border-white text-white': category !== 'news'
                    }"
                    @click="category = 'news'"
                >
                    {{ $t('news') }}
                </a>
                <a
                    href="javascript:"
                    class="capitalize px-4 py-2 rounded-full sm:text-xs relative"
                    :class="{
                        'bg-white border-2 border-neutral text-neutral': category === 'learn',
                        'bg-neutral border-2 border-white text-white': category !== 'learn'
                    }"
                    @click="category = 'learn'"
                >
                    {{ $t('learn') }}
                </a>
                <a
                    href="javascript:"
                    class="capitalize px-4 py-2 rounded-full sm:text-xs relative"
                    :class="{
                        'bg-white border-2 border-neutral text-neutral': category === 'help',
                        'bg-neutral border-2 border-white text-white': category !== 'help'
                    }"
                    @click="category = 'help'"
                >
                    {{ $t('help') }}
                </a>
            </div>
        </header-circle-container>
        <div
            v-if="computedArticles"
            class="mx-8 my-6 flex flex-col space-y-2 -mt-16 cursor-pointer"
        >
            <custom-card
                v-for="article in computedArticles"
                :key="article.id"
                :cover="article.cover"
                @click="evt => readArticle(evt, article)"
            >
                <div
                    class="font-bold"
                >
                    {{ article.subject }}
                </div>
                <div
                    class="my-2 leading-tight"
                >
                    {{ article.description }}
                </div>
                <div class="font-bold capitalize flex justify-between space-x-2 items-center">
                    <div class="flex-1">
                        {{ article.category }} · {{ moment(article.created_at).format('DD MMM YYYY') }}
                    </div>
                    <a
                        href="javascript:"
                        class="rounded-full w-8 h-8 bg-sky-200 text-blue-700 text-center flex justify-center items-center share-btn"
                        @click="shareArticle(article)"
                    >
                        <font-awesome-icon
                            icon="fa-solid fa-share-nodes"
                            size="1x"
                        />
                    </a>
                </div>
            </custom-card>
        </div>
    </div>
</template>

<script setup>
import CustomCard from "~/components/custom-card.vue";
import HeaderCircleContainer from "~/components/header-circle-container.vue";
import {computed, inject, onMounted, ref} from "vue";
import axios from "axios";
import moment from "moment";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";
import {useRouter} from "vue-router";
import {useI18n} from "vue-i18n";

const category = ref('all');
const articles = ref([]);
const pageReady = ref(false);
const $router = useRouter();
const $helper = inject('$helper');
const i18n = useI18n();

const computedArticles = computed(() => {
    if (!articles.value || !articles.value.length) return [];

    return articles.value.filter(r => {
        if (category.value === 'all') return true;
        else return category.value === r.category;
    });
});

onMounted(async () => {
    try {
        const data = await axios.post('/home');

        if (data.articles) {
            articles.value = data.articles;
        }
    } catch (e) {
        console.log(e);
    } finally {
        pageReady.value = true;
    }
});

const shareArticle = async (article) => {
    // Create new element
    let el = document.createElement('textarea');
    let r = $router.resolve({name: 'user.home.article', params: {
            id: article.id
    }});
    // Set value (string to be copied)
    el.value = window.location.protocol + '//' + window.location.host + r.fullPath;
    // Set non-editable to avoid focus and move outside of view
    el.setAttribute('readonly', '');
    el.setAttribute('style', {position: 'absolute', left: '-9999px'})
    document.body.appendChild(el);
    // Select text inside element
    el.select();
    // Copy text to clipboard
    document.execCommand('copy');
    // Remove temporary element
    document.body.removeChild(el);

    if (navigator && navigator.share) {
        await navigator.share({
            title: article.subject,
            url: r.fullPath,
        });
    }
};

const readArticle = async (evt, article) => {
    if (evt.target.closest('.share-btn') === null) {
        await $router.push({
            name: 'user.home.article',
            params: {
                id: article.id
            }
        });
    }
}
</script>
